import sys
import socket
import os
import threading
import time

MAX_MEM_BUFFER_SIZE = 8192
PORT_DEFAULT = 8765

def send(client_socket, message):
    # 发送数据到服务器
    client_socket.sendall(message.encode())

    # 接收服务器的响应
    data = client_socket.recv(MAX_MEM_BUFFER_SIZE).decode()

    while 'abort' in data :
        print(data)
        client_socket.sendall(message.encode())
        data = client_socket.recv(MAX_MEM_BUFFER_SIZE).decode()

    # 打印接收到的数据
    print(threading.get_native_id(), 'rmdb>', message, '\n', data)


def send_file_content(thread_id, host, port):
    # 创建一个socket对象
    client_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

    try:
        # 连接到服务器
        client_socket.connect((host, port))

        for i in range(100):
            message = 'insert into t values (%d);' % (i*5 + thread_id)
            send(client_socket, message)
        
        time.sleep(10)

        message = 'select count(*) as count_index from t where id<10000;'
        send(client_socket, message)

        message = 'select count(*) as count_row from t;'
        send(client_socket, message)

        time.sleep(10)

        for i in range(100):
            message = 'delete from t where id=%d;' % (i*5 + thread_id)
            send(client_socket, message)
        
        time.sleep(10)

        message = 'select count(*) as count_index from t where id<10000;'
        send(client_socket, message)

        message = 'select count(*) as count_row from t;'
        send(client_socket, message)

    except ConnectionRefusedError:
        print('Connection refused. Make sure the server is running.')

    finally:
        # 关闭socket连接
        client_socket.close()

def main():

    # 定义服务器地址和端口
    host = '127.0.0.1'
    port = PORT_DEFAULT

    client_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    client_socket.connect((host, port))

    # message = 'create table t(id int);'
    # send(client_socket, message)
    #
    # message = 'create index t(id);'
    # send(client_socket, message)

    # 创建10个线程
    num_threads = 3
    threads = []

    for i in range(num_threads):
        thread = threading.Thread(target=send_file_content, args=(i, host, port))
        threads.append(thread)

    # 启动所有线程
    for thread in threads:
        thread.start()

    # 等待所有线程完成
    for thread in threads:
        thread.join()

if __name__ == '__main__':
    main()
